// Generated from Boppi.g4 by ANTLR 4.7
package pp.s1184725.boppi.antlr;
import org.antlr.v4.runtime.tree.ParseTreeVisitor;

/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by {@link BoppiParser}.
 *
 * @param <T> The return type of the visit operation. Use {@link Void} for
 * operations with no return type.
 */
public interface BoppiVisitor<T> extends ParseTreeVisitor<T> {
	/**
	 * Visit a parse tree produced by {@link BoppiParser#program}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitProgram(BoppiParser.ProgramContext ctx);
	/**
	 * Visit a parse tree produced by {@link BoppiParser#expr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExpr(BoppiParser.ExprContext ctx);
	/**
	 * Visit a parse tree produced by the {@code parens}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitParens(BoppiParser.ParensContext ctx);
	/**
	 * Visit a parse tree produced by the {@code read}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRead(BoppiParser.ReadContext ctx);
	/**
	 * Visit a parse tree produced by the {@code declare}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitDeclare(BoppiParser.DeclareContext ctx);
	/**
	 * Visit a parse tree produced by the {@code bool}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitBool(BoppiParser.BoolContext ctx);
	/**
	 * Visit a parse tree produced by the {@code var}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVar(BoppiParser.VarContext ctx);
	/**
	 * Visit a parse tree produced by the {@code infix2}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInfix2(BoppiParser.Infix2Context ctx);
	/**
	 * Visit a parse tree produced by the {@code infix3}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInfix3(BoppiParser.Infix3Context ctx);
	/**
	 * Visit a parse tree produced by the {@code infix1}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInfix1(BoppiParser.Infix1Context ctx);
	/**
	 * Visit a parse tree produced by the {@code while}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitWhile(BoppiParser.WhileContext ctx);
	/**
	 * Visit a parse tree produced by the {@code infix4}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInfix4(BoppiParser.Infix4Context ctx);
	/**
	 * Visit a parse tree produced by the {@code infix5}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInfix5(BoppiParser.Infix5Context ctx);
	/**
	 * Visit a parse tree produced by the {@code call}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitCall(BoppiParser.CallContext ctx);
	/**
	 * Visit a parse tree produced by the {@code number}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitNumber(BoppiParser.NumberContext ctx);
	/**
	 * Visit a parse tree produced by the {@code funcDeclare}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitFuncDeclare(BoppiParser.FuncDeclareContext ctx);
	/**
	 * Visit a parse tree produced by the {@code char}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitChar(BoppiParser.CharContext ctx);
	/**
	 * Visit a parse tree produced by the {@code block}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitBlock(BoppiParser.BlockContext ctx);
	/**
	 * Visit a parse tree produced by the {@code write}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitWrite(BoppiParser.WriteContext ctx);
	/**
	 * Visit a parse tree produced by the {@code if}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitIf(BoppiParser.IfContext ctx);
	/**
	 * Visit a parse tree produced by the {@code prefix1}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitPrefix1(BoppiParser.Prefix1Context ctx);
	/**
	 * Visit a parse tree produced by the {@code assign}
	 * labeled alternative in {@link BoppiParser#singleExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAssign(BoppiParser.AssignContext ctx);
	/**
	 * Visit a parse tree produced by {@link BoppiParser#type}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitType(BoppiParser.TypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link BoppiParser#variable}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariable(BoppiParser.VariableContext ctx);
}